'use strict';

var internal = require('svelte/internal');

/* src\fa.svelte generated by Svelte v3.8.1 */

// (101:0) {#if i[4]}
function create_if_block(ctx) {
	var svg, g1, g0;

	function select_block_type(ctx) {
		if (typeof ctx.i[4] == 'string') return create_if_block_1;
		return create_else_block;
	}

	var current_block_type = select_block_type(ctx);
	var if_block = current_block_type(ctx);

	var svg_levels = [
		ctx.$$props,
		{ style: ctx.s },
		{ viewBox: `0 0 ${ctx.i[0]} ${ctx.i[1]}` },
		{ "aria-hidden": "true" },
		{ role: "img" },
		{ xmlns: "http://www.w3.org/2000/svg" }
	];

	var svg_data = {};
	for (var i_1 = 0; i_1 < svg_levels.length; i_1 += 1) {
		svg_data = internal.assign(svg_data, svg_levels[i_1]);
	}

	return {
		c() {
			svg = internal.svg_element("svg");
			g1 = internal.svg_element("g");
			g0 = internal.svg_element("g");
			if_block.c();
			internal.attr(g0, "transform", ctx.transform);
			internal.attr(g1, "transform", "translate(256 256)");
			internal.set_attributes(svg, svg_data);
		},

		m(target, anchor) {
			internal.insert(target, svg, anchor);
			internal.append(svg, g1);
			internal.append(g1, g0);
			if_block.m(g0, null);
		},

		p(changed, ctx) {
			if (current_block_type === (current_block_type = select_block_type(ctx)) && if_block) {
				if_block.p(changed, ctx);
			} else {
				if_block.d(1);
				if_block = current_block_type(ctx);
				if (if_block) {
					if_block.c();
					if_block.m(g0, null);
				}
			}

			if (changed.transform) {
				internal.attr(g0, "transform", ctx.transform);
			}

			internal.set_attributes(svg, internal.get_spread_update(svg_levels, [
				(changed.$$props) && ctx.$$props,
				(changed.s) && { style: ctx.s },
				(changed.i) && { viewBox: `0 0 ${ctx.i[0]} ${ctx.i[1]}` },
				{ "aria-hidden": "true" },
				{ role: "img" },
				{ xmlns: "http://www.w3.org/2000/svg" }
			]));
		},

		d(detaching) {
			if (detaching) {
				internal.detach(svg);
			}

			if_block.d();
		}
	};
}

// (120:8) {:else}
function create_else_block(ctx) {
	var path0, path0_d_value, path0_fill_value, path0_fill_opacity_value, path1, path1_d_value, path1_fill_value, path1_fill_opacity_value;

	return {
		c() {
			path0 = internal.svg_element("path");
			path1 = internal.svg_element("path");
			internal.attr(path0, "d", path0_d_value = ctx.i[4][0]);
			internal.attr(path0, "fill", path0_fill_value = ctx.secondaryColor || ctx.color || 'currentColor');
			internal.attr(path0, "fill-opacity", path0_fill_opacity_value = ctx.swapOpacity != false ? ctx.primaryOpacity : ctx.secondaryOpacity);
			internal.attr(path0, "transform", "translate(-256 -256)");
			internal.attr(path1, "d", path1_d_value = ctx.i[4][1]);
			internal.attr(path1, "fill", path1_fill_value = ctx.primaryColor || ctx.color || 'currentColor');
			internal.attr(path1, "fill-opacity", path1_fill_opacity_value = ctx.swapOpacity != false ? ctx.secondaryOpacity : ctx.primaryOpacity);
			internal.attr(path1, "transform", "translate(-256 -256)");
		},

		m(target, anchor) {
			internal.insert(target, path0, anchor);
			internal.insert(target, path1, anchor);
		},

		p(changed, ctx) {
			if ((changed.i) && path0_d_value !== (path0_d_value = ctx.i[4][0])) {
				internal.attr(path0, "d", path0_d_value);
			}

			if ((changed.secondaryColor || changed.color) && path0_fill_value !== (path0_fill_value = ctx.secondaryColor || ctx.color || 'currentColor')) {
				internal.attr(path0, "fill", path0_fill_value);
			}

			if ((changed.swapOpacity || changed.primaryOpacity || changed.secondaryOpacity) && path0_fill_opacity_value !== (path0_fill_opacity_value = ctx.swapOpacity != false ? ctx.primaryOpacity : ctx.secondaryOpacity)) {
				internal.attr(path0, "fill-opacity", path0_fill_opacity_value);
			}

			if ((changed.i) && path1_d_value !== (path1_d_value = ctx.i[4][1])) {
				internal.attr(path1, "d", path1_d_value);
			}

			if ((changed.primaryColor || changed.color) && path1_fill_value !== (path1_fill_value = ctx.primaryColor || ctx.color || 'currentColor')) {
				internal.attr(path1, "fill", path1_fill_value);
			}

			if ((changed.swapOpacity || changed.secondaryOpacity || changed.primaryOpacity) && path1_fill_opacity_value !== (path1_fill_opacity_value = ctx.swapOpacity != false ? ctx.secondaryOpacity : ctx.primaryOpacity)) {
				internal.attr(path1, "fill-opacity", path1_fill_opacity_value);
			}
		},

		d(detaching) {
			if (detaching) {
				internal.detach(path0);
				internal.detach(path1);
			}
		}
	};
}

// (114:8) {#if typeof i[4] == 'string'}
function create_if_block_1(ctx) {
	var path, path_d_value, path_fill_value;

	return {
		c() {
			path = internal.svg_element("path");
			internal.attr(path, "d", path_d_value = ctx.i[4]);
			internal.attr(path, "fill", path_fill_value = ctx.color || ctx.primaryColor || 'currentColor');
			internal.attr(path, "transform", "translate(-256 -256)");
		},

		m(target, anchor) {
			internal.insert(target, path, anchor);
		},

		p(changed, ctx) {
			if ((changed.i) && path_d_value !== (path_d_value = ctx.i[4])) {
				internal.attr(path, "d", path_d_value);
			}

			if ((changed.color || changed.primaryColor) && path_fill_value !== (path_fill_value = ctx.color || ctx.primaryColor || 'currentColor')) {
				internal.attr(path, "fill", path_fill_value);
			}
		},

		d(detaching) {
			if (detaching) {
				internal.detach(path);
			}
		}
	};
}

function create_fragment(ctx) {
	var if_block_anchor;

	var if_block = (ctx.i[4]) && create_if_block(ctx);

	return {
		c() {
			if (if_block) if_block.c();
			if_block_anchor = internal.empty();
		},

		m(target, anchor) {
			if (if_block) if_block.m(target, anchor);
			internal.insert(target, if_block_anchor, anchor);
		},

		p(changed, ctx) {
			if (ctx.i[4]) {
				if (if_block) {
					if_block.p(changed, ctx);
				} else {
					if_block = create_if_block(ctx);
					if_block.c();
					if_block.m(if_block_anchor.parentNode, if_block_anchor);
				}
			} else if (if_block) {
				if_block.d(1);
				if_block = null;
			}
		},

		i: internal.noop,
		o: internal.noop,

		d(detaching) {
			if (if_block) if_block.d(detaching);

			if (detaching) {
				internal.detach(if_block_anchor);
			}
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	let { style = '', icon, fw = false, flip = false, pull = false, rotate = false, size = false, color, primaryColor, secondaryColor, primaryOpacity = 1, secondaryOpacity = 0.4, swapOpacity = false } = $$props;

let i;
let s;
let transform;

	$$self.$set = $$new_props => {
		$$invalidate('$$props', $$props = internal.assign(internal.assign({}, $$props), $$new_props));
		if ('style' in $$new_props) $$invalidate('style', style = $$new_props.style);
		if ('icon' in $$new_props) $$invalidate('icon', icon = $$new_props.icon);
		if ('fw' in $$new_props) $$invalidate('fw', fw = $$new_props.fw);
		if ('flip' in $$new_props) $$invalidate('flip', flip = $$new_props.flip);
		if ('pull' in $$new_props) $$invalidate('pull', pull = $$new_props.pull);
		if ('rotate' in $$new_props) $$invalidate('rotate', rotate = $$new_props.rotate);
		if ('size' in $$new_props) $$invalidate('size', size = $$new_props.size);
		if ('color' in $$new_props) $$invalidate('color', color = $$new_props.color);
		if ('primaryColor' in $$new_props) $$invalidate('primaryColor', primaryColor = $$new_props.primaryColor);
		if ('secondaryColor' in $$new_props) $$invalidate('secondaryColor', secondaryColor = $$new_props.secondaryColor);
		if ('primaryOpacity' in $$new_props) $$invalidate('primaryOpacity', primaryOpacity = $$new_props.primaryOpacity);
		if ('secondaryOpacity' in $$new_props) $$invalidate('secondaryOpacity', secondaryOpacity = $$new_props.secondaryOpacity);
		if ('swapOpacity' in $$new_props) $$invalidate('swapOpacity', swapOpacity = $$new_props.swapOpacity);
	};

	$$self.$$.update = ($$dirty = { icon: 1, fw: 1, pull: 1, size: 1, style: 1, flip: 1, rotate: 1 }) => {
		if ($$dirty.icon) { $$invalidate('i', i = (icon && icon.icon) || [0, 0, '', [], '']); }
		if ($$dirty.fw || $$dirty.pull || $$dirty.size || $$dirty.style) { {
      let float;
      let width;
      const height = '1em';
      let lineHeight;
      let fontSize;
      let textAlign;
      let verticalAlign = '-.125em';
      const overflow = 'visible';
    
      if (fw) {
        textAlign = 'center';
        width = '1.25em';
      }
    
      if (pull) {
        float = pull;
      }
    
      if (size) {
        if (size == 'lg') {
          fontSize = '1.33333em';
          lineHeight = '.75em';
          verticalAlign = '-.225em';
        } else if (size == 'xs') {
          fontSize = '.75em';
        } else if (size == 'sm') {
          fontSize = '.875em';
        } else {
          fontSize = size.replace('x', 'em');
        }
      }
    
      const styleObj = {
        float,
        width,
        height,
        'line-height': lineHeight,
        'font-size': fontSize,
        'text-align': textAlign,
        'vertical-align': verticalAlign,
        overflow,
      };
      let styleStr = '';
      for (const prop in styleObj) {
        if (styleObj[prop]) {
          styleStr += `${prop}:${styleObj[prop]};`;
        }
      }
      $$invalidate('s', s = styleStr + style);
    } }
		if ($$dirty.flip || $$dirty.rotate) { {
      let t = '';
    
      if (flip) {
        let flipX = 1;
        let flipY = 1;
        if (flip == 'horizontal') {
          flipX = -1;
        } else if (flip == 'vertical') {
          flipY = -1;
        } else {
          flipX = flipY = -1;
        }
        t += ` scale(${flipX} ${flipY})`;
      }
    
      if (rotate) {
        t += ` rotate(${rotate} 0 0)`;
      }
    
      $$invalidate('transform', transform = t);
    } }
	};

	return {
		style,
		icon,
		fw,
		flip,
		pull,
		rotate,
		size,
		color,
		primaryColor,
		secondaryColor,
		primaryOpacity,
		secondaryOpacity,
		swapOpacity,
		i,
		s,
		transform,
		$$props,
		$$props: $$props = internal.exclude_internal_props($$props)
	};
}

class Fa extends internal.SvelteComponent {
	constructor(options) {
		super();
		internal.init(this, options, instance, create_fragment, internal.safe_not_equal, ["style", "icon", "fw", "flip", "pull", "rotate", "size", "color", "primaryColor", "secondaryColor", "primaryOpacity", "secondaryOpacity", "swapOpacity"]);
	}
}

module.exports = Fa;
